﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace ConsoleApp1.RegexTest
{
    internal partial class RegexTest
    {
        public static void Test3()
        {
            var msg = "      Checksum = 0x002D11B8";
            Regex checksumRegex = new Regex("^(.*)Checksum = (0x.*)$");
            var match = checksumRegex.Match(msg);
            if (match.Success &&
                match.Groups.Count > 2 &&
                match.Groups[2].Value.StartsWith("0x"))
            {

            }
        }

        public static void Test2()
        {
            var msg = "Memory [0x08000000 : 0x08010000] - Checksum : 0x00AA2428";
            Regex checksumRegex = new Regex("^(.*)Checksum : (0x.*)$");
            var match = checksumRegex.Match(msg);
            if (match.Success &&
                match.Groups.Count > 2 &&
                match.Groups[2].Value.StartsWith("0x"))
            {

            }
        }

        public static void Test()
        {
            var input = "adcGH01@%!";
            var result = SlugRegex().Replace(input, "test");
        }

        [GeneratedRegex("[^0-9A-Za-z _-]", RegexOptions.NonBacktracking, 5)]
        private static partial Regex SlugRegex();
    }
}
