﻿
using AwInitilizer.Assist;
using Azure;
using ConsoleApp1.CertificateTest;
using ConsoleApp1.Else;
using ConsoleApp1.Mile;
using ConsoleApp1.OCPPAuth;
using ConsoleApp1.RegexTest;
using ConsoleApp1.StringCheck;
using ConsoleApp1.WebSocketClient;
using FluentFTP;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Net;
using System.Net.NetworkInformation;
using System.Reflection;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;

Signature.Test();
return;

StringCheck1.Run();
return;

var value = "{\"result\":\"Success\",\"message\":{\"SystemId\":\"\",\"SystemDateTime\":\"\",\"FactoryConfiguration\":\"1\",\"RfidCardNumEndian\":\"\",\"PsuAcInputType\":\"\",\"PhaseLossPolicy\":0,\"AuthorisationMode\":0,\"isAPP\":0,\"isQRCode\":0,\"isRFID\":0,\"QRCodeMadeMode\":0,\"Intensity\":0,\"QRCodeContent\":\"\"}}";
var test = JsonConvert.DeserializeObject<EvAuthMsg>(value);
var msg = test.message;
var type = test.message.GetType();

if (type == typeof(JObject))
{
    var msgText = JsonConvert.SerializeObject(msg);
}

if (type == typeof(System.String))
{

}

//var result0 = await CapitalbusMile.GetMile("EAL-1093");
var result0 = await BaoruhMile.GetMile("SYV-0001");
var a = 1;

Ebus_capital.Test();

var test1 = "123abcABC";
var result1 = GetIntStringFromString(test1);

string GetIntStringFromString(string s)
{
    string toReturn = string.Empty;
    var array = Encoding.ASCII.GetBytes(s);
    if (array.Length == 0)
    {
        return toReturn;
    }
    toReturn = GetString(GetInt(array[0]));
    for (int index = 1 ; index < array.Length; index ++)
    {
        toReturn = $"{toReturn}{GetString(GetInt(array[index]))}";
    }
    return toReturn;
}

string GetString(int i)
{
    return i.ToString("00");
}

int GetInt(byte c)
{
    if (c < 32 || c > 126)
    {
        return 0;
    }
    return c - 32;
}

//var dic = new Dictionary<string, int?>();
//dic["test"] = null;

//var test1 = "sftp://charger:1@qAAtrE6och@104.41.191.35/home/charger/V0.67_ramdisk_AXLU111001D1P1_CSU30_RootFileSystem_1832C5CF_FTPs.gz";
//var test2 = "sftp://charger:1@qAAtrE6och@evscket.phihong.com/home/charger/V0.67_ramdisk_AXLU111001D1P1_CSU30_RootFileSystem_1832C5CF_FTPs.gz";

//var result3 = new Uri(test2);

var temp = await EvApi.GetVersion();
Console.WriteLine(JsonConvert.SerializeObject(temp));
Console.ReadKey();

return;

ConsoleApp1.DI.CricularDependency.Test();

RegexTest.Test3();

EnumerableSequenceEqualTest.Test();

await EvHttpClientLoggerTest.Test();

RegexTest.Test();

CertificateRequestTest.Test2();

await WebSocketClientTest.Test();

string uidString1 = "BB51A7D9-1F69-415C-94C0-AC6DE76A70D9";
Guid uid = Guid.Parse(uidString1);
var uidRestored =  uid.ToString();

ServicePointManager.ServerCertificateValidationCallback +=
    (sender, cert, chain, sslPolicyErrors) => true;
System.Net.ServicePointManager.Expect100Continue = false;

IPAddress ipAddress = IPAddress.Parse("192.168.80.179");
Ping pingSender = new Ping();
PingReply pingReply = pingSender.Send(ipAddress, 50);
pingSender.Dispose();

Encoding.RegisterProvider(CodePagesEncodingProvider.Instance);
await CapitalbusMile.GetMile("EAL-1095");

var cards = await TTIA_API.GetCards();
var mappedTrasactions = await TTIA_API.GetTrasactions(cards);

var ftp = await GetFtpClient();
try
{
    var list = await ftp.GetListing("/");
}
catch(Exception e)
{

}


long secs = 1587362347;
var baseTime = DateTime.Parse("1970-01-01 00:00:00 Z").ToUniversalTime();
var addedTime = baseTime.AddSeconds(secs);
Console.WriteLine(addedTime);


string data = """
    1587362347{"code":106,"vehiclelicense":"ea-123"}zv1234
    """;
var result = MD5ToHex_UTF8(data);

var appBuilder = WebApplication.CreateBuilder();
var app = appBuilder.Build();

app.UseWebSockets();

app.MapGet("/test", () =>
{
    return "hello!";
});

app.Use(async (context, next) =>
{
    if (context.Request.Path == "/ws")
    {
        if (context.WebSockets.IsWebSocketRequest)
        {
            using var webSocket = await context.WebSockets.AcceptWebSocketAsync();
        }
        else
        {
            context.Response.StatusCode = StatusCodes.Status400BadRequest;
        }
    }
    else
    {
        await next(context);
    }

});

app.Urls.Add("http://*:80");

app.Run();

 String MD5ToHex_UTF8(String TextToHash)
{
    if ((TextToHash == null) || (TextToHash.Length == 0))
    {
        return String.Empty;
    }

    MD5 md5 = new MD5CryptoServiceProvider();
    byte[] textToHash = Encoding.UTF8.GetBytes(TextToHash);
    byte[] result = md5.ComputeHash(textToHash);
    return BitConverter.ToString(result).Replace("-", "").ToLower();
}


static async Task<IAsyncFtpClient> GetFtpClient()
{
    IAsyncFtpClient toReturn = null;
    try
    {
        
        //var token = new CancellationToken();
        toReturn = new AsyncFtpClient("ecar.capitalbusgroup.com.tw", new NetworkCredential("eCarCharge", "aBcd@0505"), port: 2121);
        toReturn.Config.LogUserName = false;
        toReturn.Config.LogPassword = false;
        toReturn.Config.LogHost = false;
        toReturn.Config.ConnectTimeout = 30_000;

        // conn.SslProtocols = System.Security.Authentication.SslProtocols.Tls12;
        //toReturn.Config.DataConnectionType = FtpDataConnectionType.PASV;
        toReturn.Config.DataConnectionType = FtpDataConnectionType.PASV;
        toReturn.Config.EncryptionMode = FtpEncryptionMode.None;
        //toReturn.Config.EncryptionMode = FtpEncryptionMode.None;
        toReturn.ValidateCertificate += (control, e) =>
        {
            e.PolicyErrors = System.Net.Security.SslPolicyErrors.None;
            e.Accept = true;
        };

        await toReturn.Connect();
        return toReturn;
    }
    catch (Exception ex)
    {
        if (toReturn is not null)
        {
            toReturn.Dispose();
        }

        return null;
    }
}