﻿using Dapper;
using Microsoft.Data.SqlClient;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

public static class TTIA_API
{
    public static string webDbString = "data source=prd-ebus.database.windows.net;initial catalog=StandardOCPP_Web;;persist security info=True;user id=ebus_user;password=R859tdk%az;MultipleActiveResultSets=True;App=EntityFramework;TrustServerCertificate=true;Max Pool Size=200;Connection Lifetime=0;Pooling=true;";
    public static string mainDbString = "data source=prd-ebus.database.windows.net;initial catalog=StandardOCPP_Main;;persist security info=True;user id=ebus_user;password=R859tdk%az;MultipleActiveResultSets=True;App=EntityFramework;TrustServerCertificate=true;Max Pool Size=1024;Connection Lifetime=0;Pooling=true;Min Pool Size=150;";

    public static async Task<List<string>> GetCards()
    {
        string cmd = """
            SELECT [IdTag]
            FROM [dbo].[VehicleCustomer]
            """;
        using var webconn = new SqlConnection(webDbString);
        webconn.Open();
        var quesryResult = await webconn.QueryAsync<string>(cmd);
        return quesryResult.ToList();
    }

    internal static async Task<List<string>> GetTrasactions(List<string> cards)
    {
        try
        {

            string cmd = """
            SELECT [Id]
            FROM [dbo].[TransactionRecord]
            WHERE StartIdTag in @StartIdTag
            """;
            var param = new DynamicParameters();
            param.Add("@StartIdTag", cards);
            using var mainconn = new SqlConnection(mainDbString);
            mainconn.Open();
            var quesryResult = await mainconn.QueryAsync<string>(cmd, param);
            return quesryResult.ToList();
        }
        catch(Exception e)
        {
            throw;
        }
    }
}
