﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace ConsoleApp1.bellwether
{
    internal class BellwetherTest
    {
        static void test3()
        {
            var url = "http://plm.bellwether-corp.com:8081/BW_Service.asmx/ExportSolarenergy_All_1";
            //RestClient client = new RestClient(url);
            //RestRequest restRequest = new RestRequest() { Method = Method.GET };
            //var requestResult = client.Execute(restRequest);
            //var gettask = client.GetStringAsync(url);
            //var result = gettask.Result;
            //var result = requestResult.Content;
            var result = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\r\n<string xmlns=\"http://tempuri.org\">{\"code\":200,\"status\":\"success\",\"data\":[{\"Area\":\"集團\",\"Unit\":\"年\",\"Energy\":\"865576\",\"CO2EmissionSaved\":\"419766\",\"EquivalentTreesPlanted\":\"15321447\"},{\"Area\":\"\",\"Unit\":\"日\",\"Energy\":\"1590\",\"CO2EmissionSaved\":\"784\",\"EquivalentTreesPlanted\":\"28607\"},{\"Area\":\"平鎮\",\"Unit\":\"日\",\"Energy\":\"842\",\"CO2EmissionSaved\":\"428\",\"EquivalentTreesPlanted\":\"15640\"},{\"Area\":\"昆山\",\"Unit\":\"日\",\"Energy\":\"748\",\"CO2EmissionSaved\":\"355\",\"EquivalentTreesPlanted\":\"12968\"},{\"Area\":\"越南\",\"Unit\":\"日\",\"Energy\":\"---\",\"CO2EmissionSaved\":\"---\",\"EquivalentTreesPlanted\":\"---\"},{\"Area\":\"美洲\",\"Unit\":\"日\",\"Energy\":\"---\",\"CO2EmissionSaved\":\"---\",\"EquivalentTreesPlanted\":\"---\"},{\"Area\":\"\",\"Unit\":\"\",\"Energy\":\"---\",\"CO2EmissionSaved\":\"---\",\"EquivalentTreesPlanted\":\"---\"}],\"message\":\"\"}</string>";
            //result = result.Replace('\n',' ').Replace('\r',' ');
            Regex regex = new Regex(".*\"data\":(\\[.*\\]).*");
            var matchResult = regex.Match(result);
            if (matchResult != null && matchResult.Success && matchResult.Groups.Count > 1)
            {
                result = matchResult.Groups[1].Value;
            }
            var solarEnergyModels = JsonConvert.DeserializeObject<SolarEnergyModel[]>(result);
        }

        class SolarEnergyModel
        {
            public string Area { get; set; }
            public string Energy { get; set; }
            public string CO2EmissionSaved { get; set; }
            public string EquivalentTreesPlanted { get; set; }
        }
    }
}
